#ifndef NerfStatTrakConfig_h
#define NerfStatTrakConfig_h


/**
 * Display configuration
**/
#define NerfDigits 6


/**
 * Display pin configuration
 *
 * Clock and data are used only when not using SPI,
 * clock speed is only for SPI
**/
#define NerfLatchPin 10
#define NerfDataPin 11
#define NerfClockPin 12
#define NerfClockSpeed 1600000UL


/**
 * Button configuration
**/
#define NerfButtonLongPressThreshold 1000


/**
 * Button pin configuration
**/
#define NerfButtonA 3
#define NerfButtonB 2
#define NerfButtonArmed 4

// Must be usable for interrupts
#define NerfButtonWakeUp 2
#define NerfButtonWakeUpState LOW



/**
 * Default state configuration
**/
#define NerfDefaultIntroTime 1000
#define NerfDefaultSleepTime 10000


#endif