#ifndef SegmentDisplayConfig_h
#define SegmentDisplayConfig_h

/**
 * Enable SPI support
 *
 * If not defined, shiftOut will be used. Use setClockPin and
 * setDataPin instead to change the defaults.
 *
 * When using SPI, use setClockSpeed to match your target.
**/
//#define SDUseSPI


/**
 * Shift register chaining order
 *
 * If defined, the segment mask is pushed out first followed
 * by the digit mask. In other words, connect D1, D2, etc to
 * the first shift register and A, B, etc to the second.
 *
 * If not defined, the order is reversed.
**/
#define SDPushSegmentsFirst


/**
 * Support large digit delays (> 15000 microseconds)
 *
 * If not defined, delayMicroseconds() will always be used,
 * which is currently only accurate up to 16383, but it saves
 * the cost of checking the value.
 *
 * If you want to delay the digits further, most likely
 * for multiplexing demonstration purposes only, enable this
 * to automatically fall back to delay().
**/
#define SPHandleLargeDelays


/**
 * Debug output
 *
 * If defined, outputs a trace of every call using Serial.print.
 * The performance cost is of course massive, you probably
 * only want to enable this while debugging the library.
**/
//#define SDSerialDebug

#endif