#ifndef StateDefault_h
#define StateDefault_h

#include "StateHandler.h"


/**
 * Default state
 *
 * Start by showing the current counter mode (hits or shots),
 * then display the value.
 *
 * A:         Add hit
 * B short:   Toggle between hits and shots and restart state
 * A + B:     Display "Error user unknwn"
 * B long:    Display "You lost the game" animation (losethegame.com - you're welcome!)
**/
class DefaultState : public AbstractStateHandler
{
  private:
    bool showIntro = true;
    unsigned long introStart;
    unsigned long lastAction;

    void setShowHits(bool value);

  public:
    static bool ShowHits;

    void setup();
    void loop();
};

#endif